/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package mapmaking;

import java.awt.Color;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.event.MouseMotionAdapter;
import java.awt.event.MouseMotionListener;
import java.awt.event.MouseWheelEvent;
import java.awt.event.MouseWheelListener;
import java.awt.image.BufferedImage;
import javax.swing.JPanel;

/**
 *
 * @author Aksel Kvitberg
 */
public class ImageViewer extends JPanel {

	BufferedImage img;
	Main m;
	int drawX = 0;
	int drawY = 0;
	int prevMouseX = 0;
	int prevMouseY = 0;

	public static final double scalePreset[] = {0.08, 0.12, 0.16, 0.25, 0.33, 0.5, 0.66, 1, 2};
//	double scalePreset[] = {2, 1, 0.66, 0.5, 0.33, 0.25, 0.16, 0.12, 0.08};
	int scale = 7;

	public ImageViewer(Main m) {
		this.m = m;
		this.addMouseMotionListener(new MouseMotionListener() {

			public void mouseDragged(MouseEvent e) {

				int mouseX = e.getX();
				int mouseY = e.getY();
				int diffX = mouseX - prevMouseX;
				int diffY = mouseY - prevMouseY;
				prevMouseX = mouseX;
				prevMouseY = mouseY;

				drawX = drawX + diffX;
				drawY = drawY + diffY;
				repaint();
			}

			public void mouseMoved(MouseEvent e) {}
		});

		this.addMouseListener(new MouseListener() {

			public void mouseClicked(MouseEvent e) {

			}

			public void mousePressed(MouseEvent e) {
				prevMouseX = e.getX();
				prevMouseY = e.getY();
			}

			public void mouseReleased(MouseEvent e) {

			}

			public void mouseEntered(MouseEvent e) {

			}

			public void mouseExited(MouseEvent e) {

			}
		});

		this.addMouseWheelListener(new MouseWheelListener() {

			public void mouseWheelMoved(MouseWheelEvent e) {
				System.out.println(e.getWheelRotation());
				scale -= e.getWheelRotation(); // Returns -1 or 1;
				if (scale >= scalePreset.length)
					scale = scalePreset.length-1;
				if (scale < 0)
					scale = 0;
				System.out.println("scale: " + scale);
				repaint();
			}
		});
	}

	public void setImage(BufferedImage im) {
		img = im;
		repaint();
	}

	public void updateImage() {
		repaint();
	}

	public void drawNewTrees() {
		m.drawTrees();
		repaint();
	}

	public void paintComponent(Graphics gsimple) {
		Graphics2D g = (Graphics2D)gsimple;

		g.setColor(Color.LIGHT_GRAY);
		g.fillRect(0, 0, this.getWidth(), this.getHeight());
		if (img != null) {
			g.setColor(Color.WHITE);
			g.fillRect(drawX, drawY, (int) (scalePreset[scale] * img.getWidth()), (int) (scalePreset[scale] * img.getHeight()));
			g.setColor(Color.BLACK);
			g.drawRect(drawX, drawY, (int) (scalePreset[scale] * img.getWidth()), (int) (scalePreset[scale] * img.getHeight()));
			g.drawImage(img, drawX, drawY, (int) (scalePreset[scale] * img.getWidth()),(int) (scalePreset[scale] * img.getHeight()), this);
		}
	}
}
